<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;


class TaskStatus extends \Doctrine\ORM\EntityRepository{

    public function findTaskStatus($organizationId,$filtersString = ''){
        $query = <<<SQL
        SELECT * FROM (
            SELECT 	TS.ID, TS.ORGANIZATION, TS.CONTROL, TS.LABEL, TS.TASK_TYPE, TS.IS_ISSUE,IS_TASK,
                        TS.CREATED_BY, TS.CREATED_AT, TS.UPDATED_BY, TS.UPDATED_AT,
                        TT.LABEL AS TASK_TYPE_LABEL, TT.INITIAL_TASK_STATUS,TS.CONTROL AS OLD_CONTROL,
                        (CASE WHEN TS.ID = TT.INITIAL_TASK_STATUS THEN 'Y' ELSE 'N' END) AS IS_INITIAL,
                        TS.USED_IN_TASK, TS.USED_IN_ISSUE
              FROM	    TASK_STATUS TS
              LEFT JOIN TASK_TYPE TT ON (TS.TASK_TYPE = TT.ID)
              WHERE	    TS.ORGANIZATION = :organizationId
              AND       TS.IS_PROJECT = 'N')
        WHERE 1=1
        $filtersString
        ORDER BY ID ASC
SQL;
        $params = array(
            'organizationId' => $organizationId
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        foreach($result as &$item){
            $item['TASK_TYPE'] = (int)$item['TASK_TYPE']; // we need this for select-native
        }
        return $result;
    }
}