import { AlertServiceCustom } from '@/services/AlertServiceCustom';
import { InstanceService } from '@/services/InstanceService';
import { LoadingService } from '@zeedhi/common';
import { Http } from '@zeedhi/core';

export class DMBudgetSoliClosedController {
    public callRelationship = '';

    public callType = 'I';

    private validateEditBudget = true;

    private disabledEditBudget = false;

    public async changeTabBudgetSoliClosed(params: any) {
		try {
			this.callRelationship = params.component.events.callRelationship();
			const tabBudgetSoliClosed = InstanceService.getInstanceTabs('tabBudgetSoliClosed');
			const tab = tabBudgetSoliClosed.tabs[tabBudgetSoliClosed.activeTab];
			setTimeout(async () => {
				if (tab.events && tab.events.change && typeof tab.events.change === 'function') {
					await tab.events.change(params);
				}
			}, 100);
		} catch (e) {
			setTimeout(async () => {
				await this.changeTabBudgetSoliClosed(params);
			}, 1000);
		}
	}

    public async changeTabFrameBudgetItensSoliClosed() {
		LoadingService.show();
		try {
			const budgetItensGridInstanceClosed = InstanceService.getInstanceTekGrid('gridbudgetItensSoliClosed');
			const formMaintenanceCostSoliClosed = InstanceService.getInstanceZdForm('formMaintenanceCostSoliClosed');
			formMaintenanceCostSoliClosed.children.forEach((row) => {
				formMaintenanceCostSoliClosed.value[row.name] = 0;
			});
			budgetItensGridInstanceClosed.datasource.get();
			const response = await Http.post('/maintenanceCostSoli', {
				CALL_RELATIONSHIP: this.callRelationship,
				CALL_TYPE: this.callType,
			});
			formMaintenanceCostSoliClosed.children.forEach((row) => {
				if (response && response.data && response.data.data && response.data.data[row.name]) {
					formMaintenanceCostSoliClosed.value[row.name] = response.data.data[row.name];
				} else {
					formMaintenanceCostSoliClosed.value[row.name] = 0;
				}
			});
			formMaintenanceCostSoliClosed.value.changed = false;
			formMaintenanceCostSoliClosed.value.Soli_ID = this.callRelationship;
			this.validateEditBudget = !!formMaintenanceCostSoliClosed.value.VALIDATE_EDIT;
			this.disabledEditBudget = !formMaintenanceCostSoliClosed.value.VALIDATE_EDIT;
			if (!formMaintenanceCostSoliClosed.value.VALIDATE_EDIT) {
				AlertServiceCustom.customErrorAlert(AlertServiceCustom.getMessageByCode(formMaintenanceCostSoliClosed.value.VALIDATE_ERROR));
			}
			LoadingService.hide();
		} catch (e) {
			LoadingService.hide();
		}
	}

    public async changeTabFrameBudgetInstallmentsSoliClosed() {
		this.changeTabFrameBudgetItensSoliClosed();
	}
}
