import { AlertService } from '@zeedhi/common';
import Messages from '@/services/Messages';

export class AlertServiceCustom extends AlertService {
	public static getMessageByCode(code: string) {
		let message = Messages[code];
		if (!message) {
			message = Messages.ERROR_DEAFULT;
		}
		return message;
	}

	public static defaultSaveSuccessAlert() {
		this.show({
			name: 'success_save_alert',
            color: 'success',
            text: Messages.SUCCESS_SAVE_DEAFULT,
            timeout: 3000,
            showDismiss: true,
            top: true,
            right: true,
		});
	}

    public static defaultDeleteSuccessAlert() {
		this.show({
			name: 'success_delete_alert',
            color: 'success',
            text: Messages.SUCCESS_DELETE_DEAFULT,
            timeout: 3000,
            showDismiss: true,
            top: true,
            right: true,
		});
	}

	public static customAlert(text: string) {
		AlertService.show({
			name: 'custom_error_alert',
			text,
			color: 'alert',
			timeout: 3000,
			showDismiss: true,
			top: true,
			right: true,
		});
	}

    public static customErrorAlert(text: string) {
        AlertService.show({
            name: 'custom_error_alert',
            text,
            color: 'error',
            timeout: 3000,
            showDismiss: true,
            top: true,
            right: true,
        });
    }
}
